Improve the discussion of the absolute-filter alternative.
[rsync/qnx.git] / testsuite / rsync.fns
blob7ea2a9c404190e64eba9ba2207dc2f97063215e8
1 #! /bin/sh
3 # Copyright (C) 2001 by Martin Pool <mbp@samba.org>
5 # General-purpose test functions for rsync.
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License version
9 # 2 as published by the Free Software Foundation.
11 # This program is distributed in the hope that it will be useful, but
12 # WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14 # Lesser General Public License for more details.
16 # You should have received a copy of the GNU Lesser General Public
17 # License along with this program; if not, write to the Free Software
18 # Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
20 tmpdir="$scratchdir"
21 fromdir="$tmpdir/from"
22 todir="$tmpdir/to"
23 chkdir="$tmpdir/chk"
25 # For itemized output:
26 all_plus='+++++++++'
27 allspace=' '
28 dots='.....' # trailing dots after changes
30 # Berkley's nice.
31 PATH="$PATH:/usr/ucb"
33 if diff -u "$suitedir/rsync.fns" "$suitedir/rsync.fns" >/dev/null 2>&1; then
34 diffopt="-u"
35 else
36 diffopt="-c"
39 HOME="$scratchdir"
40 export HOME
42 runtest() {
43 echo $ECHO_N "Test $1: $ECHO_C"
44 if eval "$2"
45 then
46 echo "$ECHO_T done."
47 return 0
48 else
49 echo "$ECHO_T failed!"
50 return 1
54 set_cp_destdir() {
55 while test $# -gt 1; do
56 shift
57 done
58 destdir="$1"
61 # Perform a "cp -p", making sure that timestamps are really the same,
62 # even if the copy rounded microsecond times on the destination file.
63 cp_touch() {
64 cp -p "${@}" || test_fail "cp -p failed"
65 if test $# -gt 2 -o -d "$2"; then
66 set_cp_destdir "${@}" # sets destdir var
67 while test $# -gt 1; do
68 destname="$destdir/`basename $1`"
69 touch -r "$destname" "$1" "$destname"
70 shift
71 done
72 else
73 touch -r "$2" "$1" "$2"
77 # Call this if you want to filter out verbose messages (-v or -vv) from
78 # the output of an rsync run (whittling the output down to just the file
79 # messages). This isn't needed if you use -i without -v.
80 filter_outfile() {
81 sed -e '/^building file list /d' \
82 -e '/^sending incremental file list/d' \
83 -e '/^created directory /d' \
84 -e '/^done$/d' \
85 -e '/ --whole-file$/d' \
86 -e '/^total: /d' \
87 -e '/^client charset: /d' \
88 -e '/^server charset: /d' \
89 -e '/^$/,$d' \
90 <"$outfile" >"$outfile.new"
91 mv "$outfile.new" "$outfile"
94 printmsg() {
95 echo "$1"
98 rsync_ls_lR() {
99 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
102 get_testuid() {
103 id 2>/dev/null | sed 's/^[^0-9]*\([0-9][0-9]*\).*/\1/'
106 check_perms() {
107 perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
108 if test $perms = $2; then
109 return 0
111 echo "permissions: $perms on $1"
112 echo "should be: $2"
113 test_fail "failed test $3"
116 rsync_getgroups() {
117 "$TOOLDIR/getgroups"
121 ####################
122 # Build test directories $todir and $fromdir, with $fromdir full of files.
124 hands_setup() {
125 # Clean before creation
126 rm -rf "$fromdir"
127 rm -rf "$todir"
129 [ -d "$tmpdir" ] || mkdir "$tmpdir"
130 [ -d "$fromdir" ] || mkdir "$fromdir"
131 [ -d "$todir" ] || mkdir "$todir"
133 # On some BSD systems, the umask affects the mode of created
134 # symlinks, even though the mode apparently has no effect on how
135 # the links behave in the future, and it cannot be changed using
136 # chmod! rsync always sets its umask to 000 so that it can
137 # accurately recreate permissions, but this script is probably run
138 # with a different umask.
140 # This causes a little problem that "ls -l" of the two will not be
141 # the same. So, we need to set our umask before doing any creations.
143 # set up test data
144 touch "$fromdir/empty"
145 mkdir "$fromdir/emptydir"
147 # a hundred lines of text or so
148 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
150 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
151 umask 0
152 ln -s nolf "$fromdir/nolf-symlink"
153 umask 022
155 cat "$srcdir"/*.c > "$fromdir/text"
156 mkdir "$fromdir/dir"
157 cp "$fromdir/text" "$fromdir/dir"
158 mkdir "$fromdir/dir/subdir"
159 echo some data > "$fromdir/dir/subdir/foobar.baz"
160 mkdir "$fromdir/dir/subdir/subsubdir"
161 if [ -r /etc ]; then
162 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
163 else
164 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
166 mkdir "$fromdir/dir/subdir/subsubdir2"
167 if [ -r /bin ]; then
168 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
169 else
170 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
173 # echo testing head:
174 # ls -lR "$srcdir" | head -10 || echo failed
178 ####################
179 # Many machines do not have "mkdir -p", so we have to build up long paths.
180 # How boring.
181 makepath() {
182 for p in "${@}"; do
183 (echo " makepath $p"
185 # Absolut Unix.
186 if echo $p | grep '^/' >/dev/null
187 then
188 cd /
191 # This will break if $p contains a space.
192 for c in `echo $p | tr '/' ' '`
194 if [ -d "$c" ] || mkdir "$c"
195 then
196 cd "$c" || return $?
197 else
198 echo "failed to create $c" >&2; return $?
200 done)
201 done
206 ###########################
207 # Run a test (in '$1') then compare directories $2 and $3 to see if
208 # there are any difference. If there are, explain them.
210 # So normally basically $1 should be an rsync command, and $2 and $3
211 # the source and destination directories. This is only good when you
212 # expect to transfer the whole directory exactly as is. If some files
213 # should be excluded, you might need to use something else.
215 checkit() {
216 failed=
218 # We can just write everything to stdout/stderr, because the
219 # wrapper hides it unless there is a problem.
221 echo "Running: \"$1\""
222 eval "$1"
223 status=$?
224 if [ $status != 0 ]; then
225 failed="$failed status=$status"
228 echo "-------------"
229 echo "check how the directory listings compare with diff:"
230 echo ""
231 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
232 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
233 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed="$failed dir-diff"
235 echo "-------------"
236 echo "check how the files compare with diff:"
237 echo ""
238 if [ "x$4" != x ]; then
239 echo " === Skipping (as directed) ==="
240 else
241 diff -r $diffopt "$2" "$3" || failed="$failed file-diff"
244 echo "-------------"
245 if [ -z "$failed" ] ; then
246 return 0
249 echo "Failed: $failed"
250 return 1
254 build_rsyncd_conf() {
255 # Build an appropriate configuration file
256 conf="$scratchdir/test-rsyncd.conf"
257 echo "building configuration $conf"
259 port=2612
260 pidfile="$scratchdir/rsyncd.pid"
261 logfile="$scratchdir/rsyncd.log"
262 hostname=`uname -n`
264 uid_setting='uid = 0'
265 gid_setting='gid = 0'
266 case `get_testuid` in
267 0) ;;
269 # Non-root cannot specify uid & gid settings
270 uid_setting="#$uid_setting"
271 gid_setting="#$gid_setting"
273 esac
275 cat >"$conf" <<EOF
276 # rsyncd configuration file autogenerated by $0
278 pid file = $pidfile
279 use chroot = no
280 munge symlinks = no
281 hosts allow = localhost 127.0.0.0/24 192.168.0.0/16 10.0.0.0/8 $hostname
282 log file = $logfile
283 log format = %i %h [%a] %m (%u) %l %f%L
284 transfer logging = yes
285 exclude = ? foobar.baz
286 max verbosity = 4
287 $uid_setting
288 $gid_setting
290 [test-from]
291 path = $fromdir
292 read only = yes
293 comment = r/o
295 [test-to]
296 path = $todir
297 read only = no
298 comment = r/w
300 [test-scratch]
301 path = $scratchdir
302 read only = no
304 [test-hidden]
305 path = $fromdir
306 list = no
309 # Build a helper script to ignore exit code 23
310 ignore23="$scratchdir/ignore23"
311 echo "building help script $ignore23"
313 cat >"$ignore23" <<'EOT'
314 if "${@}"; then
315 exit
318 ret=$?
320 if test $ret = 23; then
321 exit
324 exit $ret
326 chmod +x "$ignore23"
330 build_symlinks() {
331 mkdir "$fromdir"
332 date >"$fromdir/referent"
333 ln -s referent "$fromdir/relative"
334 ln -s "$fromdir/referent" "$fromdir/absolute"
335 ln -s nonexistent "$fromdir/dangling"
336 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
339 test_fail() {
340 echo "$@" >&2
341 exit 1
344 test_skipped() {
345 echo "$@" >&2
346 echo "$@" > "$tmpdir/whyskipped"
347 exit 77
350 # It failed, but we expected that. don't dump out error logs,
351 # because most users won't want to see them. But do leave
352 # the working directory around.
353 test_xfail() {
354 echo "$@" >&2
355 exit 78
358 # Determine what shell command will appropriately test for links.
359 ln -s foo "$scratchdir/testlink"
360 for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
362 for switch in -h -L
364 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
365 then
366 # how nice
367 TEST_SYMLINK_CMD="$cmd $switch"
368 # i wonder if break 2 is portable?
369 break 2
371 done
372 done
373 # ok, now get rid of it
374 rm "$scratchdir/testlink"
377 if [ "x$TEST_SYMLINK_CMD" = 'x' ]
378 then
379 test_fail "Couldn't determine how to test for symlinks"
380 else
381 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
385 # Test whether something is a link, allowing for shell peculiarities
386 is_a_link() {
387 # note the variable contains the first option and therefore is not quoted
388 $TEST_SYMLINK_CMD "$1"
392 # We need to set the umask to be reproducible. Note also that when we
393 # do some daemon tests as root, we will setuid() and therefore the
394 # directory has to be writable by the nobody user in some cases. The
395 # best thing is probably to explicitly chmod those directories after
396 # creation.
398 umask 022